package com.bureau.devicefingerprint.datacollectors

import android.content.Context
import android.content.Intent
import android.content.pm.ResolveInfo
import android.os.Build
import android.provider.MediaStore
import android.util.Log
import com.bureau.devicefingerprint.models.devicedataholder.CameraInjectionInfo

interface CameraInjectionInfoProvider {
    fun getCameraInjection(): CameraInjectionInfo
}
class CameraInjectionInfoProviderImpl(private val context: Context) : CameraInjectionInfoProvider {
    override fun getCameraInjection(): CameraInjectionInfo {
        val packageManager = context.packageManager
        val intent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
        val list: List<ResolveInfo> = packageManager.queryIntentActivities(
            intent,
            0
        )
        for (res in list) {
            Log.d("balatag", res.activityInfo.packageName + " " + res.activityInfo.name)
        }
        val packageNames = list.map {
            it.activityInfo.packageName
        }
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
            return CameraInjectionInfo(false, packageNames)
        }
        return CameraInjectionInfo(
            list.size > 1,
            packageNames
        )
    }
}
